// -*- tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 2 -*-
// vi: set et ts=4 sw=2 sts=2:
#include "config.h"
#include "geometry.hh"

/* === instantiating 2D objects === */

extern template
SubTriangulationGeometry<1,2,double>::
SubTriangulationGeometry(const Dune::GeometryType & t,
                         const ParamMatrix & _c);
extern template
SubTriangulationGeometry<1,2,double>::
SubTriangulationGeometry(const Dune::GeometryType & t,
                         const LinearParamMatrix & _c);
extern template
double SubTriangulationGeometry<1,2,double>::
integrationElement(const LocalVector &local) const;
extern template
const SubTriangulationGeometry<1,2,double>::GlobalVector
SubTriangulationGeometry<1,2,double>::
global (const LocalVector &local) const;

extern template
SubTriangulationGeometry<2,2,double>::
SubTriangulationGeometry(const Dune::GeometryType & t,
                         const ParamMatrix & _c);
extern template
SubTriangulationGeometry<2,2,double>::
SubTriangulationGeometry(const Dune::GeometryType & t,
                         const LinearParamMatrix & _c);
extern template
double SubTriangulationGeometry<2,2,double>::
integrationElement(const LocalVector &local) const;
extern template
const SubTriangulationGeometry<2,2,double>::JacobianMatrix &
SubTriangulationGeometry<2,2,double>::
jacobianInverseTransposed (const LocalVector & local) const;
extern template
const SubTriangulationGeometry<2,2,double>::GlobalVector
SubTriangulationGeometry<2,2,double>::
global (const LocalVector &local) const;

/* === instantiating 3D objects === */

extern template
SubTriangulationGeometry<2,3,double>::
SubTriangulationGeometry(const Dune::GeometryType & t,
                         const ParamMatrix & _c);
extern template
SubTriangulationGeometry<2,3,double>::
SubTriangulationGeometry(const Dune::GeometryType & t,
                         const LinearParamMatrix & _c);
extern template
double SubTriangulationGeometry<2,3,double>::
integrationElement(const LocalVector &local) const;
extern template
const SubTriangulationGeometry<2,3,double>::GlobalVector
SubTriangulationGeometry<2,3,double>::
global (const LocalVector &local) const;

extern template
SubTriangulationGeometry<3,3,double>::
SubTriangulationGeometry(const Dune::GeometryType & t,
                         const ParamMatrix & _c);
extern template
SubTriangulationGeometry<3,3,double>::
SubTriangulationGeometry(const Dune::GeometryType & t,
                         const LinearParamMatrix & _c);
extern template
double SubTriangulationGeometry<3,3,double>::
integrationElement(const LocalVector &local) const;
extern template
const SubTriangulationGeometry<3,3,double>::JacobianMatrix &
SubTriangulationGeometry<3,3,double>::
jacobianInverseTransposed (const LocalVector & local) const;
extern template
const SubTriangulationGeometry<3,3,double>::GlobalVector
SubTriangulationGeometry<3,3,double>::
global (const LocalVector &local) const;
