// -*- tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 2 -*-
// vi: set et ts=4 sw=2 sts=2:
#ifndef DUNE_UDG_COMMON_SHARED_PTR_TOOLS_HH
#define DUNE_UDG_COMMON_SHARED_PTR_TOOLS_HH

#include <dune/common/shared_ptr.hh>

namespace Dune {

  template <typename T, typename O>
  Dune::shared_ptr<T> wrap_into_shared_ptr (O & o)
  {
    return stackobject_to_shared_ptr(o);
  }

  template <typename T, typename O>
  Dune::shared_ptr<T> wrap_into_shared_ptr (shared_ptr<O> o)
  {
    return o;
  }

  template <typename T, typename O>
  Dune::shared_ptr<T> wrap_into_shared_ptr (O const * o)
  {
    return make_shared(o);
  }

};

#endif
