// -*- tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 2 -*-
// vi: set et ts=4 sw=2 sts=2:
#ifndef DUNE_UDG_COMMON_UTILITIES_HH
#define DUNE_UDG_COMMON_UTILITIES_HH

template< typename VirtualSubTriangulation >
class LocallyForceRefinement
{
public:
  LocallyForceRefinement(VirtualSubTriangulation & st_)
    : st(st_), old(st.forceRefinement())
  { st.forceRefinement() = true; }

  ~LocallyForceRefinement()
  { st.forceRefinement() = old; }

private:
  VirtualSubTriangulation & st;
  bool old;
};

#endif
