// -*- tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 2 -*-
// vi: set et ts=4 sw=2 sts=2:
#ifndef DUNE_DG_LAGRANGESHAPEFUNCTIONS_HH
#define DUNE_DG_LAGRANGESHAPEFUNCTIONS_HH

#include "lagrangeshapefunctions.hh"
#include "monomialshapefunctions.hh"

namespace Dune {

  template<typename C, typename T, int d, int maxOrder>
  class DGLagrangeShapeFunctionSetContainer :
    public LagrangeShapeFunctionSetContainer<C,T,d>
  {
    typedef LagrangeShapeFunctionSetContainer<C,T,d> BaseType;
  public:
    // compile time sizes
    enum { dim=d };
    enum { comps=1 };
    enum { maxsize=MonomialShapeFunctionSetSize<d,maxOrder>::maxSize };

    // exported types
    typedef C CoordType;
    typedef T ResultType;

    //! type of objects in the container
    typedef LagrangeShapeFunctionSet<C,T,d> value_type;
    typedef LagrangeShapeFunctionSet<C,T,d> ShapeFunctionSet;

    const value_type& operator() (GeometryType type, int order) const
    {
      static GeometryType simplex(GeometryType::simplex, dim);
      return BaseType::operator()(simplex,order);
    }
  };

}

#endif
