// -*- tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 2 -*-
// vi: set et ts=4 sw=2 sts=2:
#ifndef SPARSITY_SETUP_HH
#define SPARSITY_SETUP_HH

namespace Dune {

  template<typename Matrix, typename Vector, typename GridView>
  void setupNeighborSparsity(Matrix &A, Vector &b, const GridView &gridview);

  template<typename Matrix, typename Vector, typename GridView, typename Mapper>
  void setupNeighborSparsity(Matrix &A, Vector &b, const GridView &gridview, const Mapper & mapper);

  template<typename Matrix, typename Vector, typename GridView>
  void setupDiagonalSparsity(Matrix &A, Vector &b, const GridView &gridview);

  template<typename Matrix, typename Vector, typename GridView, typename Mapper>
  void setupDiagonalSparsity(Matrix &A, Vector &b, const GridView &gridview, const Mapper & mapper);

} // end namespace Dune

#include "sparsitysetup.cc"

#endif // SPARSITY_SETUP_HH
